/*
    Copyright Jesus Perez <jesusprubio gmail com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

'use strict';


// Private stuff

var ExploitSearch = require('exploitsearch'),

    HELP = {
        description: 'Find vulnerabilities and exploit for an specifig service version (using exploitsearch.net API)',
        options: {
            query: {
                type: 'allValid',
                description: 'String to search',
                defaultValue: 'Apache 7.4'
            },
            timeout: {
                type: 'positiveInt',
                description: 'Time to wait for a response (ms)',
                defaultValue: 5000
            },
            onlyExploits : {
                type: 'yesNo',
                description: 'Look only for exploits, not vulns',
                defaultValue: 'no'
            }
        }
    };


// Public stuff

module.exports.help = HELP;

module.exports.run = function (options, callback) {
    var reqOptions = {
            timeout: parseInt(options.timeout),
            onlyExploits: options.timeout
        },
        client;

    client = new ExploitSearch(reqOptions);
    client.search(options.query, callback);
};
